import torch
import torch.nn as nn
import torch.nn.functional as F

def CFLLoss(X, Y, model, Hs, Ps, alpha = 5000):
    original_loss = F.cross_entropy(X, Y)
    new_loss = 0
    #  print(alpha)
    for p, h, o in zip(model.parameters(), Hs, Ps):
        if p.requires_grad:
            tmp_loss = (1 / 2) * torch.multiply(h, (p - o) ** 2).sum()
            new_loss += tmp_loss
    #print(original_loss, new_loss)
    final_alpha = alpha
    # while final_alpha * new_loss > 10 * original_loss:
    #     final_alpha = 0.1 * final_alpha
    return original_loss + final_alpha * new_loss
